export default class FormCore {
    constructor(options: FormCoreOptions);
    private emitter;
    validator: Validator;
    fields: Map<any, any>;
    private initialSchema;
    private initialData;
    state: State;
    reset(): void;
    submit(): {
        data: Data;
        errors: Errors;
    };
    update(update: {
        path: (string | number)[];
        value: any;
    }): void;
    validateAll(data: Data): any;
    getState(): any;
    setState(state: Partial<State>): void;
    changed(state: State): void;
    setProperty(property: Properties, value: any): void;
    on(event: Events, callback: (state: any) => void): void;
    off(event: Events, callback: (state: any) => void): void;
}
export type Schema = any;
export type Data = {
    [x: string]: any;
};
export type Errors = {
    [x: string]: string[];
};
export type Properties = "readOnly";
export type PropertyOptions = {
    readOnly?: boolean;
};
export type Events = "submit" | "changed";
export type FormCoreOptions = {
    data: Data;
    schema: Schema;
    properties?: PropertyOptions;
};
export type State = {
    data: Data;
    errors: Errors;
    schema: Schema;
    properties: PropertyOptions;
};
import { Validator } from "./validation";
